
//#include	"GUI.h"



/*=====================================================================*/

static	void 	ADS7843_SPI_Start(void);
static	void 	ADS7843_WrCmd(U8 cmd);
static	 U16 	ADS7843_Read(void);

/*=====================================================================*/

/*=====================================================================*/
// A/D Í¨µÀÑ¡ÔñÃüÁî×ÖºÍ¹¤×÷¼Ä´æÆ÷
#define	CHX 	0x90 	//Í¨µÀY+µÄÑ¡Ôñ¿ØÖÆ×Ö	//0x94
#define	CHY 	0xd0	//Í¨µÀX+µÄÑ¡Ôñ¿ØÖÆ×Ö	//0xD4

//Ð´ADS7843µÄIO¿ØÖÆ¿Ú pinout
//++++++++ pinout sw_spi +++++++++
#define sck_touch_swport  	0
#define miso_touch_swport 	0
#define mosi_touch_swport 	0
#define sck_touch_swpin  		7
#define miso_touch_swpin 		8
#define mosi_touch_swpin 		9

#define touch_csport	0
#define touch_cspin		6
#define touch_irqport	2
#define touch_irqpin	13

#define mosi_h		  pinSET(mosi_touch_swport,mosi_touch_swpin)
#define mosi_l		  pinCLR(mosi_touch_swport,mosi_touch_swpin)
#define  sck_h		  pinSET(sck_touch_swport,sck_touch_swpin)
#define  sck_l		  pinCLR(sck_touch_swport,sck_touch_swpin)
#define  miso		  pinVAL(miso_touch_swport,miso_touch_swpin)



//-------- pinout swspi ---------

//#define	SPI_MISO		((rPDATC&(1<<0)))
//#define	SPI_MOSI(a)		rPDATC = ( rPDATC&(~(1<<2)) ) | ((a&1)<<2)
//#define	SPI_SCK(a)		rPDATC = ( rPDATC&(~(1<<4)) ) | ((a&1)<<4)

#define	SPI_CS(a)		touch_irqport = (touch_irqport &(~(1<<touch_cspin)) ) | ((a&1)<<touch_cspin)

#define	SPI_MISO		miso

//¶ÁADS7843µÄIO¿ØÖÆ¿Ú

//#define TP_IRQ		((rPDATG>>3) & 0x1)
#define TP_IRQ		((touch_irqport>>touch_irqpin) & 0x1)

/*=====================================================================*/


/*=====================================================================*/
/*
void __irq ADS7843_Interrupt_Serve( void )
{

	//Touch_Screen_Press_100ms();

	//TP_Time_Count=0;


	rI_ISPC = BIT_EINT2 ;	//clear pending_bit

}
*/
/*=====================================================================*/


static	int	ADS7843_Init(void)

{
	U16 j;
//SPI_CS	->	GPC3			Output
//SPI_SCK	->	GPC4			Output
//SPI_MOSI	->	GPC2			Output
//SPI_MISO	->	GPC0			Input
//IRQ		->	GPG3(Ex_Int3)	Input

	pinDIRout(sck_touch_swport,sck_touch_swpin);
	pinDIRin(miso_touch_swport,miso_touch_swpin);
	pinDIRout(mosi_touch_swport,mosi_touch_swpin);
	pinDIRout(touch_csport,touch_cspin);

	pinSEL(touch_irqport,touch_irqport,1);
	pinDIRout(touch_irqport,touch_irqport);

	////
/*
	rPCONC &= (~((3<<8)|(3<<6)|(3<<4)|(3<<0)));//sck
	rPCONC |= ((1<<8)|(1<<6)|(1<<4)|(0<<0));//miso
	rPUPC  &= (~((1<<4)|(1<<3)|(1<<2)|(1<<0)));//mosi

	rPCONG &= (~(3<<6));//cs
	rPUPG  &= (~(1<<3));//irq
*/

    ADS7843_SPI_Start();
    ADS7843_WrCmd( CHX ) ;
	for( j = 0; j < 100; j++ );		//200ns
	ADS7843_Read() ;

	ADS7843_WrCmd( CHY ) ;
	for( j = 0; j < 100; j++ );		//200ns
	ADS7843_Read() ;

	return 1;


}

/*=====================================================================*/

static	int	ADS7843_IsDown(void)
{


		if(!TP_IRQ)
		{
			return 1;
		}
		else
		{
			return 0;
		}


}

/*=====================================================================*/

static	void ADS7843_SPI_Start( void )
{
    sck_l;
	SPI_CS(1);
	mosi_h;
    sck_h;
    SPI_CS(0);	      		//Ð¾Æ¬ÔÊÐí

}

/*=====================================================================*/

static	void ADS7843_WrCmd(U8 cmd)
{
	U8 buf, i, j ;


    sck_l;

	for( i = 0; i < 8; i++ )
	{
		buf = (cmd >> (7-i)) & 0x1 ;	//MSBÔÚÇ°,LSBÔÚºó
		SPI_MOSI(buf);	 	//Ê±ÖÓÉÏÉýÑØËø´æDIN

		for( j = 0; j < 50; j++ );	//200ns
		sck_l;			//¿ªÊ¼·¢ËÍÃüÁî×Ö

		for( j = 0; j < 50; j++ );	//200ns
		sck_h;			//Ê±ÖÓÂö³å£¬Ò»¹²8¸ö

		for( j = 0; j < 50; j++ );	//200ns
		sck_l;			//Ê±ÖÓÂö³å£¬Ò»¹²8¸ö

	}


}

/*=====================================================================*/

static U16 ADS7843_Read(void)
{
	U16 buf ;

	U8 i, j ;



	buf=0;

	for( i = 0; i < 12; i++ )
	{
		buf = buf << 1 ;

		sck_h;
		for( j = 0; j < 50; j++ );		//200ns
		sck_l;
		for( j = 0; j < 50; j++ );	//Ê±ÖÓÏÂ½µÑØ¶ÁÈ¡,Ò»¹²12¸ö,MSBÔÚÇ°,LSBÔÚºó

		if ( SPI_MISO )
		{
			buf = buf + 1 ;
		}

		for( j = 0; j < 50; j++ );		//200ns



	}




	return( buf ) ;
}

/*=====================================================================*/


static	int	ADS7843_Rd_Addata(int *X_Addata,int *Y_Addata)
{

	U16		i,j,x_addata,y_addata;

	ADS7843_SPI_Start() ;
	for( j = 0; j < 10; j++ );			//40ns
//	while ( TP_BUSY ) ;					//Èç¹ûBUSY£¬µÈ´ýÖ±µ½×ª»»Íê±Ï£¬Õâ¸ö¿ÉÒÔ²»ÓÃ

	x_addata=0;
	y_addata=0;


	for(i=8;i>0;i--)					//²ÉÑù8´Î.
	{
		ADS7843_WrCmd( CHX ) ;
		for( j = 0; j < 50; j++ );		//200ns
		y_addata += ADS7843_Read() ;
		for( j = 0; j < 50; j++ );		//200ns

		ADS7843_WrCmd( CHY ) ;
		for( j = 0; j < 50; j++ );		//200ns
		x_addata += ADS7843_Read() ;
		for( j = 0; j < 50; j++ );		//200ns

	}

	////


	x_addata>>=3;
	y_addata>>=3;						//AVG.
	////

	*X_Addata=x_addata;
	*Y_Addata=y_addata;
	return 1;

}

/*=====================================================================*/


static	int	GetTSCalData(U8 *buf)
{
	U8	i,size;
	U8	dat[20];
	////

	size=sizeof(struct TS_CAL_DAT );

	////
	for(i=0;i<size;i++){

		IIC_Read(System_EEPROM,(TS_CAL_DAT_ADR_BASE+i),&buf[i]);

	}

	////
	#if(GUI_DBG)
//	Uart_Output_Hex(0,0,20,buf);
	#endif
}

/*=====================================================================*/

static	int	SaveTSCalData(U8 *buf)
{

	U8	i,size;
	int j;
	////
	Uart_Puts(0,"SaveTSCalData\n");
	size=sizeof(struct TS_CAL_DAT );

	////
	for(i=0;i<size;i++){

		//Uart_Printf(0,"-> %d\n",i);

		IIC_Write(System_EEPROM,(TS_CAL_DAT_ADR_BASE+i),*(buf+i));
		//Delay_n15ms(30/15);
		for(j=100000;j>0;j--);
	}

	////


}

/*=====================================================================*/

static	int ADS7843_Subpend(void)
{
	#if(GUI_DBG)
	Uart_Puts(0,"ADS7843 Subpend!\n");
	#endif
}

/*=====================================================================*/

static	int ADS7843_Resume(void)
{

	#if(GUI_DBG)
	Uart_Puts(0,"ADS7843 Resume!\n");
	#endif
}

/*=====================================================================*/

struct	GUI_IAL_TS	Fit239A_TS_ADS7843={

		ADS7843_Init,
		GetTSCalData,
		SaveTSCalData,
		ADS7843_IsDown,
		ADS7843_Rd_Addata,
		ADS7843_Subpend,
		ADS7843_Resume,


};


/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/

