void init_vs(void){
#if use_ssp
init_ssp0_2();
#else
init_swspi();
#endif
init_vs_pins();
}

void vs_writeRegister(u8 adr,u16 command){
xcs_l;//xcs_l;    /* Pull XCS low, now SPI writes go to SCI port     */
  SPIPutChar(0x02);      /* Send SPI Byte, then wait for byte to be sent.   */
  SPIPutChar(adr);      /* 0x02 was WRITE command, 0x00 is register number */
  SPIPutChar(command>>8);      /* This byte goes to MSB                           */
  SPIPutChar(command & 0xff);      /* ..and this is LSB. (0x20=Allow Test Mode)       */
xcs_h;//xcs_h;  /* Pull XCS high, now SPI writes don't go to SCI port. */
}

unsigned int vs_readRegister (unsigned char addressbyte){
  unsigned int resultvalue = 0;
  xdcs_h;
  xcs_l;
  SPIPutChar(0x03);
  SPIPutChar((addressbyte));
  resultvalue = (SPIGetChar(0xff)<< 8);
  resultvalue |= SPIGetChar(0xff);
 xcs_h;
  return resultvalue;
}

void VsSineTest(char freq){
vs_writeRegister(0,0x0820);
//while (dreq==0);// Wait for DREQ = 1                               */
vs_sendSinedata(0x53,0xef,0x6e,freq);wait;
vs_sendSinedata(0x45,0x78,0x69,0x74);
}


//====================================================================
// VS1003B   VS1003B   VS1003B   VS1003B   VS1003B   VS1003B   VS1003B //
void vs_hellotest(){
	  unsigned char *p;
	  unsigned int i,ix=0;
vs_writeRegister (SCI_MODE, 0x0804); /* Newmode, Reset, No L1-2 */
// VS1011 Takt setzen, 12.228 Mhz mit Takverdoppler
vs_writeRegister(SCI_CLOCKF, 0x9800);
ssp0_fast;
// Samplerate auf 44100 Hz setzen (siehe VS1011 application note)
vs_writeRegister(SCI_AUDATA, 0xAC45);




lgi(14,1,vs_readRegister(11));
//Mp3WriteRegister(0,0x08,0x20);//TMode
//Mp3SetVolume(00,30); // Set initial volume (20 = -10dB)
lgh(15,1,vs_readRegister(0));

//p=&xHelloMP3[0];


p = xHelloMP3; // Point "p" to the beginning of array
while (p <= &xHelloMP3[sizeof(xHelloMP3)-1]) {
	xdcs_h;
	while (dreq==0) { ;}
      xdcs_l; // Pull XDCS low

      SPIPutChar(*p++); // Send SPI byte, You can actually send 32 bytes here before checking for DREQ again
ix++;
}


lgi(1,15,ix);
vs_wait;             /* Wait until Atmel MCU signals SPI write complete */


 int MP3Status = 0, MP3Clock = 0, MP3Mode = 0, vsVersion = 0, volume = 0;

 MP3Status = vs_readRegister(SCI_STATUS);
 MP3Clock = vs_readRegister(SCI_CLOCKF);
 MP3Mode = vs_readRegister(SCI_MODE);
 vsVersion = (MP3Status >> 4) & 0x000F;
 volume = vs_readRegister(SCI_VOL);
 lgh(20,1,   MP3Mode);
 lgh(20,6,MP3Clock);
 lgh(20,12,volume);
 lgh(20,18,vsVersion);
 lgh(20,24,MP3Status);
}



void vs_write32Byte (unsigned char *buf,u32 zlfifo) {
   u8 i = 0,x=0,xx=0;
   while (dreq==0){led1_on;}
   led1_off;
   xdcs_l;
   for (i = 0; i < 32; i++) {
//	   x=*(buf+i+zlfifo);
//	   xx=buf+i+zlfifo;
	   SPIPutChar(*(buf+i+zlfifo));
   }
   xdcs_h;
}

/*
void VS1003_SendMusicBytes(uint8_t* music,int quantity){
	int i,j,k,m;

	j = quantity / 32;
	m = 0;

	SDI_ChipSelect(SET);
	for ( i = 0; i <= j; i++ )
	{
		while(GPIO_ReadInputDataBit(DREQ_PORT,DREQ_PIN) == 0);
		for (k=0; k < 32; k++)
		{
		SPIPutChar(music[m]);
		m++;
		}
	}
	//while(GPIO_ReadInputDataBit(DREQ_PORT,DREQ_PIN) == 0);
	while (m < quantity)
	{
		SPIPutChar(music[m]);
		m++;
	}
	SDI_ChipSelect(RESET);
}
*/


//====================================================================
// VS1003B   VS1003B   VS1003B   VS1003B   VS1003B   VS1003B   VS1003B //
//unsigned char buffer[4096];  128x32=4096 /* file copy buffer */
void vs_playMP3(){
u8 *p;
u16 i,ix=0,zlfifo=0;
led1_off;

vs_writeRegister (SCI_MODE, 0x0804); /* Newmode, Reset, No L1-2 */
vs_writeRegister(SCI_CLOCKF, 0x9800);// VS1011 Takt setzen, 12.228 Mhz mit Takverdoppler
ssp0_fast;
vs_writeRegister(SCI_AUDATA, 0xAC45);// Samplerate auf 44100 Hz setzen (siehe VS1011 application note)
vs_writeRegister(SCI_VOL, 0x1010);


//+++++++++++ buffer +++++++++
u32 readedBytes=0,fileSize=0;




/*
p = buffer; // Point "p" to the beginning of array
while(zlfifo<128){
// 32 byte an vs senden
led2_off;
xdcs_l;
for(i=0;i<32;i++){
	SPIPutChar(*(p+i+zlfifo*32));}//for i
xdcs_h;
p+=32;vs_wait;
zlfifo++;
}//while*/
//----------- buffer ---------


/*
while (p <= &xHelloMP3[sizeof(xHelloMP3)-1]) {
	xdcs_h;
	while (dreq==0) { ;}
      xdcs_l; // Pull XDCS low

      SPIPutChar(*p++); // Send SPI byte, You can actually send 32 bytes here before checking for DREQ again
ix++;
}*/
}

